<ui:composition xmlns="http://www.w3.org/1999/xhtml"
    xmlns:h="http://java.sun.com/jsf/html"
    xmlns:f="http://java.sun.com/jsf/core"
	xmlns:ui="http://java.sun.com/jsf/facelets"
    xmlns:p="http://primefaces.org/ui"
    xmlns:pe="http://primefaces.org/ui/extensions"
    xmlns:fn="http://java.sun.com/jsp/jstl/functions">
    <h1>
		<small>Cadastro de Clientes</small>
	</h1>
    <p:tabView id="tabCliente">
    	<p:tab title="Cadastrar">
    	<h:form id="form1" enctype="multipart/form-data">
    			<p:panel>
    			<p:toolbar id="tbOpcoes" style="margin-top: 20px">
					<p:toolbarGroup>
						<p:commandButton value="Salvar" id="botaoSalvar"
							action="#{clienteController.salvar}" style="background-color: #3C763D;"
							update="form1 growl tbOpcoes"
							rendered="#{clienteController.ativo}"
							process="@this :tabCliente:form1:panel-dialog" />
						<p:commandButton value="Novo" id="botaoNovo" style="background-color: #3C8DBC;"
		    							 actionListener="#{clienteController.ativar}" 
		    							 rendered="#{!clienteController.ativo}"
		    							 update="tbOpcoes panel-dialog panel-enderecos panel-telefones" process="@this"/>
		    							 
		    			<p:commandButton value="Cancelar" id="botaoCancelar" style="background-color: #FF0000;"
		    							 rendered="#{clienteController.ativo}"
		    							 actionListener="#{clienteController.desativar}"
		    							 update="tbOpcoes panel-dialog panel-enderecos panel-telefones" process="@this">
		    				<p:resetInput target="panel-dialog" />
		    			</p:commandButton>
					</p:toolbarGroup>
				</p:toolbar>
				</p:panel> 
				<p:panel>
				<h:outputText value="Dados do Cliente" style="font-weight: bold" />
				<p:separator title="Cliente" />
				
				<p:panelGrid columns="4" id="panel-dialog" style="padding-top: 10px;" styleClass="semBorda">
					
					<p:outputLabel value="Tipo" for="tipoCliente" />
					<p:selectOneMenu id="tipoCliente" value="#{clienteController.clienteEdicao.tipo}" disabled="#{!clienteController.ativo}">
						<f:selectItems value="#{clienteController.tiposCliente}" 
									   var="tipo" itemLabel="#{tipo.descricao}"
									   itemValue="${tipo}" />
						<p:ajax event="change" update="panel-dialog" process="@this" />
					</p:selectOneMenu>
					
					<p:outputLabel value="Cliente ou Fornecedor?" for="cliFor" />
					<p:selectOneMenu id="cliFor" value="#{clienteController.clienteEdicao.clienteFornecedor}" disabled="#{!clienteController.ativo}">
						<f:selectItem itemLabel="Cliente" itemValue="C"/>
						<f:selectItem itemLabel="Fornecedor" itemValue="F"/>
					</p:selectOneMenu>

					<p:outputLabel value="Nome" for="nome" />
					<p:inputText id="nome" disabled="#{!clienteController.ativo}"
						value="${clienteController.clienteEdicao.nome}" size="50" onkeyup="caps(this)" onblur="caps(this)">
						<p:ajax event="blur" />
					</p:inputText>
						
					<p:outputLabel value="CPF" for="cpf" rendered="#{clienteController.clienteEdicao.tipo == 'PF'}"/>
                    <p:outputLabel value="CNPJ" for="cnpj" rendered="#{clienteController.clienteEdicao.tipo == 'PJ'}"/>
                    <p:inputMask disabled="#{!clienteController.ativo}"  
                    				mask="#{clienteController.clienteEdicao.tipo == 'PJ' ? '99.999.999/9999-99' : '999.999.999-99'}" 
                    				value="#{clienteController.clienteEdicao.cpfCnpj}"  
                    				id="#{clienteController.clienteEdicao.tipo == 'PJ' ? 'cnpj' : 'cpf'}"/>

					<p:outputLabel value="E-mail" for="email" />
					<p:inputText disabled="#{!clienteController.ativo}" id="email" size="50" value="#{clienteController.clienteEdicao.email}" validatorMessage="E-mail incorreto">
						<f:validateRegex pattern="[\w\.-]*[a-zA-Z0-9_]@[\w\.-]*[a-zA-Z0-9]\.[a-zA-Z][a-zA-Z\.]*[a-zA-Z]" />
					</p:inputText>
					
					<p:outputLabel value="Informações" for="informacoes" />
					<p:inputTextarea disabled="#{!clienteController.ativo}"
						value="#{clienteController.clienteEdicao.informacoes}"
						id="informacoes" style="width: 300px;" />
					
					<p:outputLabel value="Data de Nascimento:" for="nascimento"/>
					<p:calendar id="nascimento" pattern="dd/MM/yyyy" disabled="#{!clienteController.ativo}"
						value="#{clienteController.clienteEdicao.dataNascimento}" mask="true"/>
						
					<p:outputLabel value="Empresa" for="empresa" />
					<p:inputText disabled="#{!clienteController.ativo}" size="50"
						value="#{clienteController.clienteEdicao.empresaCliente}" id="empresa"/>
						
					<p:outputLabel value="Setor" for="setor" />
					<p:inputText disabled="#{!clienteController.ativo}" size="50"
						value="#{clienteController.clienteEdicao.empresaSetor}" id="setor"/>

				</p:panelGrid>

				<h:outputText value="Endereço" style="font-weight: bold" />
				<p:separator title="Endereço" />
				
				<!-- painel para adicionar endereco -->
				<h:panelGrid columns="1" id="panel-enderecos" >
					<p:commandButton value="Adicionar Endereços" style="background-color: #3C8DBC; margin-bottom: 5px" disabled="#{!clienteController.ativo}"
						oncomplete="PF('dlgEndereco').show();" action="#{clienteController.novoEnd}"
						process="@this" update="panelEndereco" rendered="#{clienteController.clienteEdicao.enderecos.size() != 3}">
						<p:resetInput target="panelEndereco" />
					</p:commandButton>
					
					<p:dataTable id="tblEndereco" value="#{clienteController.clienteEdicao.enderecos}"
						var="enderecos" emptyMessage="Nenhum endereço Adicionado." reflow="true"
						style="margin-bottom: 5px">
						
						<p:column headerText="Logradouro">
							<h:outputLabel value="#{enderecos.logradouro}" />
						</p:column>
						<p:column headerText="Numero" width="70">
							<h:outputLabel value="#{enderecos.numero}" />
						</p:column>
						<p:column headerText="Complemento">
							<h:outputLabel value="#{enderecos.complemento}" />
						</p:column>
						<p:column headerText="Cep" width="100">
							<h:outputLabel value="#{enderecos.cep}" />
						</p:column>
						<p:column headerText="Bairro" width="100">
							<h:outputLabel value="#{enderecos.bairro}" />
						</p:column>
						<p:column headerText="Cidade/UF" width="80">
							<h:outputLabel value="#{enderecos.cidade.nome}/#{enderecos.cidade.estado.uf}" />
						</p:column>
						<p:column headerText="Tipo" width="120">
							<h:outputLabel value="#{enderecos.tipo}" />
						</p:column>
						<p:column headerText="Ações" width="70">		
							<p:commandButton icon="ui-icon-trash" process="@this"
									update=":tabCliente:form1:panel-enderecos" id="excluir-endereco-button"
									style="width: 45%" disabled="#{!clienteController.ativo}"
									action="#{clienteController.removerEndereco}">
									<p:confirm header="Remover Endereço" icon="ui-i con-alert"
										message="Você tem certeza que deseja remover este Endereço?" />
									<f:setPropertyActionListener value="#{enderecos}"
										target="#{clienteController.enderecoSelecionado}" />
							</p:commandButton>
							<p:tooltip for="excluir-endereco-button" value="Remover Endereço" />	
						</p:column>
					</p:dataTable>
				</h:panelGrid>
				<!-- fim painel para adicionar endereço -->
				
				
				<h:outputText value="Telefones" style="font-weight: bold" />
				<p:separator title="Telefones" />
				
				<!-- painel para adicionar telefone -->
				<h:panelGrid columns="1" id="panel-telefones" width="300"
					style="padding-bottom: 10px;" styleClass="semBorda">
					<p:commandButton value="Adicionar Telefone" style="background-color: #3C8DBC; width: 60%"
						process="@this" update="panelTelefone" disabled="#{!clienteController.ativo}"
						action="#{clienteController.novoTel}"
						oncomplete="PF('telefoneDialog').show()">
						<p:resetInput target="panelTelefone" />
					</p:commandButton>
					<p:dataTable value="${clienteController.clienteEdicao.telefones}" rows="3"
						paginatorAlwaysVisible="true" paginatorPosition="bottom" paginator="true"
						var="telefone" emptyMessage="Nenhum telefone foi adicionado" reflow="true">
						<p:column headerText="Número">
							<h:outputText value="#{telefone.numero}" />
						</p:column>

						<p:column headerText="Ação" width="60">
							<p:commandButton icon="ui-icon-trash" process="@this"
								update=":tabCliente:form1:panel-telefones" id="excluir-fone-button"
								style="width: 45%" disabled="#{!clienteController.ativo}"
								action="#{clienteController.delTel}">
								<p:confirm header="Remover Telefone" icon="ui-i con-alert"
									message="Você tem certeza que deseja remover este telefone?" />
								<f:setPropertyActionListener value="#{telefone}"
									target="#{clienteController.telefoneSelecionado}" />
							</p:commandButton>
							<p:tooltip for="excluir-fone-button" value="Remover Telefone" />
						</p:column>
					</p:dataTable>
				</h:panelGrid>
				</p:panel>
				<!-- fim painel para adicionar telefone -->
				
				
				<!-- inicio dialogo endereço -->
				<p:dialog id="dialog-endereco" widgetVar="dlgEndereco" modal="true" resizable="false"
					header="Novo Endereço" responsive="true">
					<h:panelGroup id="panelEndereco">
<!-- 					<p:messages id="message" autoUpdate="false" closable="true" /> -->
						<p:panelGrid columns="4" styleClass="semBorda">
							<p:outputLabel value="CEP    " for="cep" />
							<p:inputMask mask="99999-999" id="cep"
								value="#{clienteController.endereco.cep}"
								style="width: 70px;">
								<p:ajax event="change" update="panelEndereco growl" 
									listener="#{clienteController.buscarEndereco}" />
							</p:inputMask>
	
							<p:outputLabel value="Logradouro" for="logradouro" />
							<p:inputText id="logradouro"
								value="#{clienteController.endereco.logradouro}"
								style="width: 300px;" onkeyup="caps(this)" onblur="caps(this)">
								<p:ajax event="blur" />
							</p:inputText>
	
							<p:outputLabel value="Número" for="numero" />
							<p:inputText id="numero"
								value="#{clienteController.endereco.numero}"
								style="width: 70px;" onkeyup="caps(this)" onblur="caps(this)">
								<p:ajax event="blur" />
							</p:inputText>
	
							<p:outputLabel value="Complemento" for="complemento" />
							<p:inputText id="complemento"
								value="#{clienteController.endereco.complemento}"
								style="width: 300px;" onkeyup="caps(this)" onblur="caps(this)">
								<p:ajax event="blur" />
							</p:inputText>
	
							<p:outputLabel value="Cidade" for="cidade" />
							<p:autoComplete id="cidade"
								completeMethod="#{clienteController.listarCidades}"
								value="#{clienteController.endereco.cidade}" var="cidade"
								itemLabel="#{cidade.nome}" itemValue="#{cidade}"
								converter="genericConverter" forceSelection="true">
								<p:ajax event="itemSelect" update="panelEndereco"/>
							</p:autoComplete>
	
							<p:outputLabel value="Bairro" for="bairro" />
							<p:inputText id="bairro"
								value="#{clienteController.endereco.bairro}" onkeyup="caps(this)" onblur="caps(this)">
								<p:ajax event="blur" />
							</p:inputText>
	
							<p:outputLabel value="Estado" for="uf" />
							<p:inputText id="uf" disabled="true" 
								value="#{clienteController.endereco.cidade.estado.uf}"
								maxlength="2" style="width: 40px; background-color: #3C8DBC;"/>
	
							<p:outputLabel value="Tipo de Endereço" for="tipoEndereco" />
							<p:selectOneMenu id="tipoEndereco" value="#{clienteController.endereco.tipo}">
								<f:selectItems value="#{clienteController.tiposDeEnderecos}" var="end" itemLabel="#{end.toString()}" itemValue="#{end.toString()}"/>
							</p:selectOneMenu>
							
							<p:commandButton value="Salvar" style="background-color: #3C763D;margin-top: 5px"
									 action="#{clienteController.adicionarEndereco}" process="panelEndereco"
									 update="panel-enderecos panelEndereco growl"
									 oncomplete="if(!args.validationFailed) PF('dlgEndereco').hide()"/>
						</p:panelGrid>
					</h:panelGroup>
				</p:dialog>
				<!-- fim dialogo endereço -->
				
				<!-- comeco dialogo telefone -->
				<p:dialog header="Telefone" widgetVar="telefoneDialog"
					id="dialog-telefone" resizable="false" closeOnEscape="true"
					responsive="true" modal="true">
					<h:panelGroup id="panelTelefone" layout="block"
						styleClass="ui-fluid">
<!-- 						<p:messages id="msgTelefone" autoUpdate="false" /> -->

						<h:panelGrid columns="2" styleClass="panelgrid-noborder">

							<p:outputLabel value="Número" for="numero-fone" />

							<p:inputMask id="numero-fone" mask="?(99) 99999-9999"
								value="#{clienteController.telefone.numero}" />

							<br />
							<p:outputLabel />
							<p:outputLabel />
							<p:commandButton value="Inserir Telefone" process="panelTelefone"
								update="panel-telefones panelTelefone growl"
								action="#{clienteController.addTel}" style="background-color: #3C763D;"
								oncomplete="if(!args.validationFailed) PF('telefoneDialog').hide()" />

						</h:panelGrid>
					</h:panelGroup>
				</p:dialog>
				<!-- fim dialogo telefone -->
				
				<!-- começo dialogo de confirmação -->
				<p:confirmDialog header="Exclusão"
					message="Tem certeza que deseja excluir?"
					widgetVar="confirmacaoExclusao">
					<p:button value="Não"
						onclick="PF('confirmacaoExclusao').hide(); return false;" />
					<p:commandButton value="Sim"
						oncomplete="PF('confirmacaoExclusao').hide();" />
				</p:confirmDialog>
				<!-- fim dialogo de confirmação -->
			</h:form>
    	</p:tab>
    	
    	<p:tab title="Consultar" id="tabConsulta" >
    	<h:form id="form" enctype="multipart/form-data">
    		<h1>Pesquisar</h1>
    		<br/>
    		<p:panelGrid  columns="2" id="panel-consulta" style="padding-top: 10px;" styleClass="semBorda">
    		
				<p:outputLabel value="Nome:"/>
				<p:inputText maxlength="80" 
						value="#{clienteController.pesquisaCliente.nome}" 
						onkeyup="caps(this)" onblur="caps(this)" size="60">
					<p:ajax event="blur" />
				</p:inputText>
					
				<p:outputLabel value="Empresa:"/>
				<p:inputText maxlength="80" 
						value="#{clienteController.pesquisaCliente.emrpesa}" 
						onkeyup="caps(this)" onblur="caps(this)" size="60">
					<p:ajax event="blur" />
				</p:inputText>
				
				<p:outputLabel value="Setor:"/>
				<p:inputText maxlength="80" value="#{clienteController.pesquisaCliente.setor}" onkeyup="caps(this)" onblur="caps(this)">
					<p:ajax event="blur" />
				</p:inputText>
			</p:panelGrid>
			
			<center>
				<p:commandButton value="Buscar" id="buscar"
   							 actionListener="#{clienteController.consutaDeClientes}" 
   							 update=":tabCliente:form:tblCliente growl" process="@this :tabCliente:form:panel-consulta"/>	 
   			</center>
   							 
   					
				    		    	
	    	<p:dataTable id="tblCliente" emptyMessage="Nenhum Cliente" paginator="true" value="#{clienteController.listaClientes}"
	    			paginatorAlwaysVisible="true" paginatorPosition="bottom" style="margin-top: 20px" var="clientes" rows="4" reflow="true">
	    		
	    		<p:column headerText="Nome" width="220">
	    			<h:outputText value="#{clientes.nome}"/>
	    		</p:column>
	    		
	    		<p:column headerText="Cpf/Cnpj" width="130">
	    			<h:outputText value="#{clientes.cpfCnpj}"/>
	    		</p:column>
	    		
	    		<p:column headerText="E-mail" width="150">
	    			<h:outputText value="#{clientes.email}"/>
	    		</p:column>
	    		
	    		<p:column headerText="Nascimento" >
	    			<h:outputText value="#{clientes.dataNascimento}">
	    				<f:convertDateTime locale="pt_BR" pattern="dd/MM/yyyy"/>
	    			</h:outputText>
	    		</p:column>
	    		
	    		<p:column headerText="Empresa" width="135">
	    			<h:outputText value="#{clientes.empresaCliente}"/>
	    		</p:column>
	    		
	    		<p:column headerText="Setor" width="150">
	    			<h:outputText value="#{clientes.empresaSetor}"/>
	    		</p:column>
	    		
	    		<p:column headerText="Ações" width="90">
	    			<p:commandButton icon="ui-icon-pencil" title="Editar"  onclick="tabView.select(0); return false;"
	    							actionListener="#{clienteController.editar}" update=":tabCliente:form:tblCliente">
	  					<f:attribute name="clienteEditado" value="#{clientes}"/>
	    			</p:commandButton>
	    	
	    			<p:commandButton icon="ui-icon-trash" title="Excluir" actionListener="#{clienteController.excluir}" 
	    								update=":tabCliente:form:tblCliente growl">
	  					<p:confirm header="Confirmar" message="Desenja excluir Cliente ?" icon="ui-icon-alert"/>
	  					<f:attribute name="clienteExcluido" value="#{clientes}"/>
	    			</p:commandButton>
	    		</p:column>
	    		<f:facet name="footer">
	                <h:outputText value="A Consuta resultou em:  " />
		                <h:outputText value="#{fn:length(clienteController.listaClientes) == null ? 0 : fn:length(clienteController.listaClientes)}" />
		                <h:outputText value=" Clientes cadastrados. " />
                </f:facet>
	    	</p:dataTable>
	    	
			<p:confirmDialog global="true">
				<p:commandButton value="Sim" type="button"
								styleClass="ui-confirmdialog-yes" icon="ui-icon-check" />
				<p:commandButton value="Nao" type="button" 
								styleClass="ui-confirmdialog-no" icon="ui-icon-close" />
			</p:confirmDialog>
	</h:form>
	</p:tab>
	</p:tabView>
</ui:composition>